diff --git a/net/pfSense-pkg-frr/Makefile b/net/pfSense-pkg-frr/Makefile
index abea5281dc5b977c7e7cc30a970f8412eb4f1460..b2065fdb1c3df00f02ef0514f48d4527561d0f4c 100644
--- a/net/pfSense-pkg-frr/Makefile
+++ b/net/pfSense-pkg-frr/Makefile
@@ -2,7 +2,7 @@
 
 PORTNAME=	pfSense-pkg-frr
 PORTVERSION=	1.1.0
-PORTREVISION=	6
+PORTREVISION=	7
 CATEGORIES=	net
 MASTER_SITES=	# empty
 DISTFILES=	# empty
diff --git a/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf.xml b/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf.xml
index 6b612619757f227024d70fc519d1b70479f306c0..7ed42e19877f0a87aa4a80707916b324200489e7 100644
--- a/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf.xml
+++ b/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf.xml
@@ -248,7 +248,7 @@
 			<fieldname>redistributeconnectedsubnets_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>begin</combinefields>
@@ -258,7 +258,7 @@
 			<fieldname>redistributeconnectedsubnets_distlist</fieldname>
 			<description>Distribute List</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -297,7 +297,7 @@
 			<fieldname>redistributekernel_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>begin</combinefields>
@@ -307,7 +307,7 @@
 			<fieldname>redistributekernel_distlist</fieldname>
 			<description>Distribute List</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -346,7 +346,7 @@
 			<fieldname>redistributebgp_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>begin</combinefields>
@@ -356,7 +356,7 @@
 			<fieldname>redistributebgp_distlist</fieldname>
 			<description>Distribute List</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -395,7 +395,7 @@
 			<fieldname>redistributestatic_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>begin</combinefields>
@@ -405,7 +405,7 @@
 			<fieldname>redistributestatic_distlist</fieldname>
 			<description>Distribute List</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -452,7 +452,7 @@
 			<fieldname>redistributedefaultroute_routemap</fieldname>
 			<description>Route Map used to filter default route redistribution.</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(true, false)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
diff --git a/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6.xml b/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6.xml
index 5a8070014cae0811b0a82b86674c8acf78c46f69..e0d3300024ee5d1c6aa7bb66365eefd1a59c6249 100644
--- a/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6.xml
+++ b/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6.xml
@@ -238,7 +238,7 @@
 			<fieldname>redistributeconnectedsubnets_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -264,7 +264,7 @@
 			<fieldname>redistributekernel_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -290,7 +290,7 @@
 			<fieldname>redistributebgp_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -316,7 +316,7 @@
 			<fieldname>redistributestatic_routemap</fieldname>
 			<description>Route Map</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_routemap_list(false, false)]]></source>
+			<source><![CDATA[frr_get_routemap_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 			<combinefields>end</combinefields>
@@ -339,7 +339,7 @@
 			<fieldname>exportlist</fieldname>
 			<description>Uses this access list to filter route information transmitted to OSPF peers</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
@@ -348,7 +348,7 @@
 			<fieldname>importlist</fieldname>
 			<description>Uses this access list to filter route information received from OSPF peers</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
@@ -357,7 +357,7 @@
 			<fieldname>filterlist_out</fieldname>
 			<description>Uses a prefix list to filter route information transmitted to OSPF peers</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_prefixlist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_prefixlist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
@@ -366,7 +366,7 @@
 			<fieldname>filterlist_in</fieldname>
 			<description>Uses a prefix list to filter route information received from OSPF peers</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_prefixlist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_prefixlist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
diff --git a/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6_areas.xml b/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6_areas.xml
index dafb498584a1573962a3c9b6c60e12047656564d..97f4a4f73cc90c7f1fab67a332f7fbce959b9c85 100644
--- a/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6_areas.xml
+++ b/net/pfSense-pkg-frr/files/usr/local/pkg/frr/frr_ospf6_areas.xml
@@ -157,7 +157,7 @@
 			<fieldname>exportlist</fieldname>
 			<description>Uses this access list to filter summary route information transmitted to OSPF peers when acting as an ABR</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
@@ -166,7 +166,7 @@
 			<fieldname>importlist</fieldname>
 			<description>Uses this access list to filter summary route information received from OSPF peers when acting as an ABR</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_accesslist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_accesslist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
@@ -175,7 +175,7 @@
 			<fieldname>filterlist_out</fieldname>
 			<description>Uses a prefix list to filter summary route information transmitted to OSPF peers when acting as an ABR</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_prefixlist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_prefixlist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>
@@ -184,7 +184,7 @@
 			<fieldname>filterlist_in</fieldname>
 			<description>Uses a prefix list to filter summary route information received from OSPF peers when acting as an ABR</description>
 			<type>select_source</type>
-			<source><![CDATA[frr_get_prefixlist_list(false, false)]]></source>
+			<source><![CDATA[frr_get_prefixlist_list(false, true)]]></source>
 			<source_name>name</source_name>
 			<source_value>value</source_value>
 		</field>