--- /conf/backup/config-1705030903.xml	2024-01-11 22:42:08.819406000 -0500
+++ /conf/config.xml	2024-01-19 19:32:30.668749000 -0500
@@ -6,7 +6,6 @@
 		<optimization>normal</optimization>
 		<hostname>pfSense</hostname>
 		<domain>home.arpa</domain>
-		<dnsallowoverride></dnsallowoverride>
 		<group>
 			<name>all</name>
 			<description><![CDATA[All Users]]></description>
@@ -57,6 +56,8 @@
 			<loginautocomplete></loginautocomplete>
 			<ssl-certref>6584f686a3bea</ssl-certref>
 			<dashboardcolumns>2</dashboardcolumns>
+			<webguicss>pfSense-dark.css</webguicss>
+			<logincss>333333</logincss>
 		</webgui>
 		<disablenatreflection>yes</disablenatreflection>
 		<disablesegmentationoffloading></disablesegmentationoffloading>
@@ -72,6 +73,10 @@
 		<hn_altq_enable></hn_altq_enable>
 		<already_run_config_upgrade></already_run_config_upgrade>
 		<ssh></ssh>
+		<language>en_US</language>
+		<timezone>America/New_York</timezone>
+		<dns1host></dns1host>
+		<dnsallowoverride></dnsallowoverride>
 	</system>
 	<interfaces>
 		<wan>
@@ -103,39 +108,40 @@
 			<dhcp6-duid></dhcp6-duid>
 			<dhcp6-ia-pd-len>0</dhcp6-ia-pd-len>
 			<adv_dhcp6_prefix_selected_interface>wan</adv_dhcp6_prefix_selected_interface>
+			<blockpriv></blockpriv>
 		</wan>
 		<lan>
 			<enable></enable>
 			<if>em0</if>
-			<ipaddr>192.168.1.1</ipaddr>
+			<descr><![CDATA[LAN]]></descr>
+			<ipaddr>192.168.0.1</ipaddr>
 			<subnet>24</subnet>
-			<ipaddrv6>track6</ipaddrv6>
-			<subnetv6>64</subnetv6>
-			<media></media>
-			<mediaopt></mediaopt>
+			<ipaddrv6></ipaddrv6>
 			<track6-interface>wan</track6-interface>
 			<track6-prefix-id>0</track6-prefix-id>
+			<spoofmac></spoofmac>
+			<gateway></gateway>
+			<subnetv6></subnetv6>
+			<gatewayv6></gatewayv6>
 		</lan>
 	</interfaces>
-	<staticroutes>
-	</staticroutes>
+	<staticroutes></staticroutes>
 	<dhcpd>
 		<lan>
-			<enable></enable>
 			<range>
-				<from>192.168.1.100</from>
-				<to>192.168.1.199</to>
+				<from>192.168.0.100</from>
+				<to>192.168.0.200</to>
 			</range>
+			<enable></enable>
 		</lan>
 	</dhcpd>
 	<dhcpdv6>
 		<lan>
-			<enable></enable>
 			<range>
 				<from>::1000</from>
 				<to>::2000</to>
 			</range>
-			<ramode>assist</ramode>
+			<ramode>disabled</ramode>
 			<rapriority>medium</rapriority>
 		</lan>
 	</dhcpdv6>
@@ -151,6 +157,18 @@
 	</diag>
 	<syslog>
 		<filterdescriptions>1</filterdescriptions>
+		<reverse></reverse>
+		<nentries>500</nentries>
+		<logcompressiontype>bzip2</logcompressiontype>
+		<format>rfc3164</format>
+		<rotatecount></rotatecount>
+		<remoteserver></remoteserver>
+		<remoteserver2></remoteserver2>
+		<remoteserver3></remoteserver3>
+		<sourceip></sourceip>
+		<ipproto>ipv4</ipproto>
+		<logconfigchanges>enabled</logconfigchanges>
+		<nologdefaultpass></nologdefaultpass>
 	</syslog>
 	<nat>
 		<outbound>
@@ -160,39 +178,8 @@
 	<filter>
 		<rule>
 			<id></id>
-			<tracker>1705026120</tracker>
+			<tracker>0100000101</tracker>
 			<type>pass</type>
-			<interface>wan</interface>
-			<ipprotocol>inet46</ipprotocol>
-			<tag></tag>
-			<tagged></tagged>
-			<max></max>
-			<max-src-nodes></max-src-nodes>
-			<max-src-conn></max-src-conn>
-			<max-src-states></max-src-states>
-			<statetimeout></statetimeout>
-			<statetype><![CDATA[keep state]]></statetype>
-			<os></os>
-			<source>
-				<any></any>
-			</source>
-			<destination>
-				<any></any>
-			</destination>
-			<descr><![CDATA[Allow Internet]]></descr>
-			<created>
-				<time>1705026120</time>
-				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
-			</created>
-			<updated>
-				<time>1705029946</time>
-				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
-			</updated>
-		</rule>
-		<rule>
-			<id></id>
-			<tracker>1705030708</tracker>
-			<type>pass</type>
 			<interface>lan</interface>
 			<ipprotocol>inet</ipprotocol>
 			<tag></tag>
@@ -204,30 +191,24 @@
 			<statetimeout></statetimeout>
 			<statetype><![CDATA[keep state]]></statetype>
 			<os></os>
-			<protocol>tcp/udp</protocol>
 			<source>
 				<network>lan</network>
 			</source>
 			<destination>
 				<any></any>
-				<port>Browsing</port>
 			</destination>
-			<descr></descr>
+			<descr><![CDATA[Default allow LAN to any rule]]></descr>
 			<updated>
-				<time>1705030708</time>
+				<time>1705030019</time>
 				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
 			</updated>
-			<created>
-				<time>1705030708</time>
-				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
-			</created>
 		</rule>
 		<rule>
 			<id></id>
-			<tracker>1705030310</tracker>
+			<tracker>0100000102</tracker>
 			<type>pass</type>
 			<interface>lan</interface>
-			<ipprotocol>inet</ipprotocol>
+			<ipprotocol>inet6</ipprotocol>
 			<tag></tag>
 			<tagged></tagged>
 			<max></max>
@@ -237,27 +218,21 @@
 			<statetimeout></statetimeout>
 			<statetype><![CDATA[keep state]]></statetype>
 			<os></os>
-			<protocol>icmp</protocol>
-			<icmptype>any</icmptype>
 			<source>
 				<network>lan</network>
 			</source>
 			<destination>
 				<any></any>
 			</destination>
-			<descr></descr>
+			<descr><![CDATA[Default allow LAN IPv6 to any rule]]></descr>
 			<updated>
-				<time>1705030310</time>
+				<time>1705030025</time>
 				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
 			</updated>
-			<created>
-				<time>1705030310</time>
-				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
-			</created>
 		</rule>
 		<rule>
 			<id></id>
-			<tracker>0100000101</tracker>
+			<tracker>1705030708</tracker>
 			<type>pass</type>
 			<interface>lan</interface>
 			<ipprotocol>inet</ipprotocol>
@@ -270,25 +245,30 @@
 			<statetimeout></statetimeout>
 			<statetype><![CDATA[keep state]]></statetype>
 			<os></os>
+			<protocol>tcp/udp</protocol>
 			<source>
 				<network>lan</network>
 			</source>
 			<destination>
-				<any></any>
+				<network>(self)</network>
 			</destination>
-			<disabled></disabled>
-			<descr><![CDATA[Default allow LAN to any rule]]></descr>
+			<descr><![CDATA[Browsing]]></descr>
+			<created>
+				<time>1705030708</time>
+				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
+			</created>
 			<updated>
-				<time>1705030019</time>
+				<time>1705365778</time>
 				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
 			</updated>
+			<disabled></disabled>
 		</rule>
 		<rule>
 			<id></id>
-			<tracker>0100000102</tracker>
+			<tracker>1705030310</tracker>
 			<type>pass</type>
 			<interface>lan</interface>
-			<ipprotocol>inet6</ipprotocol>
+			<ipprotocol>inet</ipprotocol>
 			<tag></tag>
 			<tagged></tagged>
 			<max></max>
@@ -298,28 +278,48 @@
 			<statetimeout></statetimeout>
 			<statetype><![CDATA[keep state]]></statetype>
 			<os></os>
+			<protocol>icmp</protocol>
+			<icmptype>any</icmptype>
 			<source>
 				<network>lan</network>
 			</source>
 			<destination>
 				<any></any>
 			</destination>
-			<disabled></disabled>
-			<descr><![CDATA[Default allow LAN IPv6 to any rule]]></descr>
+			<descr></descr>
 			<updated>
-				<time>1705030025</time>
+				<time>1705030310</time>
 				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
 			</updated>
+			<created>
+				<time>1705030310</time>
+				<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
+			</created>
+			<disabled></disabled>
 		</rule>
 		<separator>
 			<lan>
 				<sep0>
 					<row>fr0</row>
-					<text><![CDATA[Internet Access]]></text>
+					<text><![CDATA[System Generated]]></text>
 					<color>bg-info</color>
 					<if>lan</if>
 				</sep0>
+				<sep1>
+					<row>fr2</row>
+					<text><![CDATA[Internet Access]]></text>
+					<color>bg-info</color>
+					<if>lan</if>
+				</sep1>
 			</lan>
+			<wan>
+				<sep0>
+					<row>fr0</row>
+					<text><![CDATA[User Generated]]></text>
+					<color>bg-info</color>
+					<if>wan</if>
+				</sep0>
+			</wan>
 		</separator>
 	</filter>
 	<shaper></shaper>
@@ -451,11 +451,13 @@
 	<vlans></vlans>
 	<qinqs></qinqs>
 	<revision>
-		<time>1705030903</time>
-		<description><![CDATA[rahul@192.168.1.100 (Local Database): Interfaces settings changed]]></description>
-		<username><![CDATA[rahul@192.168.1.100 (Local Database)]]></username>
+		<time>1705710750</time>
+		<description><![CDATA[(system): lan IP configuration from console menu]]></description>
+		<username><![CDATA[(system)]]></username>
 	</revision>
 	<gateways>
+		<defaultgw4>WAN_DHCP</defaultgw4>
+		<defaultgw6>WAN_DHCP6</defaultgw6>
 	</gateways>
 	<captiveportal></captiveportal>
 	<dnsmasq></dnsmasq>
@@ -469,6 +471,5 @@
 		<crt>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</crt>
 		<prv>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</prv>
 	</cert>
-	<ppps>
-	</ppps>
+	<ppps></ppps>
 </pfsense>